#pragma once

#include "IRoomSide.h"

class Room: public IDrawable {
public:
    enum Direction { INVALID = -1, LEFT, RIGHT, UP, DOWN };
    float get_size() const noexcept;
    void set_position(const sf::Vector2f& pos) noexcept;
    sf::Vector2f get_position() const noexcept;
    void set_side(Direction side, std::shared_ptr<IRoomSide> ptr_side) noexcept;
    std::shared_ptr<IRoomSide> get_side(Direction side);
    Direction get_direction(IRoomSide* ptr_side);
public:
    Room(float size);
public:
    std::array<std::shared_ptr<IRoomSide>, 4> m_sides;
private:
    sf::RectangleShape m_rectangle;
};